/*****************************************************************************

  utils.hpp
  
     Miscelaneous utilities for the whole library
     
   This file belongs to the KisTA library
   All rights reserved by the authors (until further License definition)

  Author: F. Herrera
  Institution: KTH
  Deparment:   ICT / Electronic Systems
  Date: 2014 February

 *****************************************************************************/


#ifndef UTILS_HPP
#define UTILS_HPP

#include "systemc.h"

namespace kista {

// class for reporting functional validation results

class validator_t: public sc_module {
public:
	validator_t();
	validator_t(std::string validation_type);
	void set_failure();
	bool failed();
	bool validated();
private:
	void end_of_simulation();
	std::string validation_t;
	bool OK;
};

// user-friendly function for 
// Enabling functional validation
void enable_functional_validation();

// setting a function failure during execution
void set_functional_failure();

// checks
// to ensure that a call is done before simulation start
void check_call_before_sim_start(std::string call_name);
// to ensure that a call is done after simulation start
void check_call_after_sim_start(std::string call_name);

// units

// conversion factor for desired output data rates
double conv_data_rate_factor(char unit);
// conversion factor for desired system units
double conv_isu_factor(char unit);

} // end namespace kista

#endif


